package com.nisum.reactive;


import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.jupiter.api.Test;
import org.mockito.BDDMockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.reactive.WebFluxTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.web.servlet.MockMvc;

import com.nisum.reactive.controller.ProductController;
import com.nisum.reactive.dto.ProductDto;
import com.nisum.reactive.service.ProductService;

import reactor.core.publisher.Flux;


@WebFluxTest(controllers = ProductController.class)

// this test class is not working getting error

public class SpringBootReactiveControllerTest {
	
	@MockBean
	private ProductService productService;
	
	@Autowired
	private MockMvc mockMvc;
	
	
	@Test
	public void getProducts() throws Exception {
	Flux<ProductDto> productDtoFlux = Flux.just(new ProductDto("102", "mobile", 1, 10000),
			new ProductDto("103", "TV", 1, 50000));
	BDDMockito.given(productService.getProducts()).willReturn(productDtoFlux);
	
	mockMvc.perform(get("/products")).andExpect(status().isOk());
	}
	
	
}
